# subclasses of TestCase and TestSuite to hold a Zope context

import unittest

class TestCase (unittest.TestCase):
	def setZopeContext (self, ctx):
		self.ZopeContext = ctx

# this needs to be tested, but it's probably quite handy if it works
class creationTest (TestCase):
  def __init__ (self, constructor, description = 'Object', parameters = (), additionalTest = None):
    TestCase.__init__ (self)
    self.constructor = constructor
    self.description = description
    self.parameters = parameters
    self.additionalTest = additionalTest
  
  def runTest (self):
    ctx = self.ZopeContext
    if not ctx.REQUEST.has_key ('title'):
      ctx.REQUEST.set ('title', 'Testing creation')
    apply (self.constructor, (ctx, 'created', ctx.REQUEST) + self.parameters)
    self.failUnless ('created' in ctx.objectIds(), 'Couldn\'t create ' + self.description)
    if not self.additionalTest: return
    try:
      self.failUnless (eval (self.additionalTest), description + ' not properly initialized')
    except:
      self.fail (description + ' not properly initialized:' + Tests.SubTraceback())

class TestSuite (unittest.TestSuite):
	def setZopeContext (self, ctx):
		self.ZopeContext = ctx
		for test in self._tests:
			test.setZopeContext (ctx)

def makeSuite(testCaseClass, prefix='test', sortUsing=cmp):
    """Returns a TestSuite instance built from all of the test functions
       in the given test case class whose names begin with the given
       prefix. The cases are sorted by their function names
       using the supplied comparison function, which defaults to 'cmp'.
       
       Adapted from unittest.makeSuite by Stephen Purcell
    """
    cases = map(testCaseClass,
                unittest.getTestCaseNames(testCaseClass, prefix, sortUsing))
    return TestSuite(cases)
	
import sys, traceback, string

def subTraceback():
	"""Handy function for printing a traceback in a
	try:
		foo
	except:
		self.fail ()
	block in a test.
	"""
	type, val, tb = sys.exc_info ()
	return '\n     ' + string.join (traceback.format_exception (type, val, tb)[1:], '     ')
